(function () {
    "use strict";

    var WIDTH_CONTENT_S = 520;
    var WIDTH_CONTENT_M = 850;

    var MAIN_TABLE = [
        {
            "cols": [{"rowspan": 2, "value": "计费<br/>收入"}, {"colspan": 2, "column": true}, {"value": "1"}],
            "index": 1,
            "title": "应征收入",
            "name": "jfsr",
            "type": "float2"
        }, // 1
        {
            "cols": [{"colspan": 2, "column": true}, {"value": "2"}],
            "index": 2,
            "title": "免征收入",
            "name": "mzsr",
            "type": "float2"
        }, // 2
        {
            "cols": [{"rowspan": 8, "value": "费<br/>额<br/>计<br/>算"}, {"colspan": 2, "column": true}, {"value": "3"}],
            "index": 3,
            "title": "减除项目期初金额",
            "name": "kcxmqcje",
            "type": "float2"
        }, // 3
        {
            "cols": [{"colspan": 2, "column": true}, {"value": "4"}],
            "index": 4,
            "title": "减除项目本期发生额",
            "name": "kcxmbqfse",
            "type": "float2"
        }, // 4
        {
            "cols": [{"rowspan": 2, "value": "本　期<br/>减除额"}, {"column": true}, {"value": "5"}],
            "index": 5,
            "title": "应征收入减除额",
            "name": "bqkce",
            "type": "float2",
            readonly: true
        }, // 5
        {
            "cols": [{"column": true}, {"value": "6"}],
            "index": 6,
            "title": "免征收入减除额",
            "name": "mzsrjce",
            "type": "float2",
            readonly: true
        }, // 6
        {
            "cols": [{"colspan": 2, "column": true}, {"value": "7=3+4-5-6"}],
            "index": 7,
            "title": "减除项目期末余额",
            "name": "kcxmqmye",
            "type": "float2",
            readonly: true
        }, // 7
        {
            "cols": [{"colspan": 2, "column": true}, {"value": "8=1-5"}],
            "index": 8,
            "title": "计费销售额",
            "name": "jfxse",
            "type": "float2"
        }, // 8
        {
            "cols": [{"colspan": 2, "column": true}, {"value": "9"}],
            "index": 9,
            "title": "费率",
            "name": "fl",
            "type": "float2",
            readonly: true
        }, // 9
        {
            "cols": [{"colspan": 2, "column": true}, {"value": "10=8×9"}],
            "index": 10,
            "title": "应缴费额",
            "name": "yjfe",
            "type": "float2",
            readonly: true
        }, // 10
        {
            "cols": [{"rowspan": 9, "value": "费<br/>额<br/>缴<br/>纳"}, {"colspan": 2, "column": true}, {"value": "11"}],
            "index": 11,
            "title": "期初未缴费额（多缴为负）",
            "name": "qcwjfe",
            "type": "float2"
        }, // 11
        {
            "cols": [{"colspan": 2, "column": true}, {"value": "12=13+14+15"}],
            "index": 12,
            "title": "本期已缴费额",
            "name": "bqyjnfe",
            "type": "float2",
            readonly: true
        }, // 12
        {
            "cols": [{"colspan": 2, "column": true}, {"value": "13"}],
            "index": 13,
            "title": "其中：本期预缴费额",
            "name": "bqyjfe",
            "type": "float2"
        }, // 13
        {
            "cols": [{"colspan": 2, "column": true}, {"value": "14"}],
            "index": 14,
            "title": "　　　本期缴纳上期费额",
            "name": "bqjnsqfe",
            "type": "float2"
        }, // 14
        {
            "cols": [{"colspan": 2, "column": true}, {"value": "15"}],
            "index": 15,
            "title": "　　　本期缴纳欠费额",
            "name": "bqjnqfe",
            "type": "float2"
        }, // 15
        {
            "cols": [{"colspan": 2, "column": true}, {"value": "16=10+11-12"}],
            "index": 16,
            "title": "期末未缴费额（多缴为负）",
            "name": "qmwjfe",
            "type": "float2",
            readonly: true
        }, // 16
        {
            "cols": [{"colspan": 2, "column": true}, {"value": "17=11-14-15"}],
            "index": 17,
            "title": "其中：欠缴费额（≧0）",
            "name": "qjfe",
            "type": "float2",
            readonly: true
        }, // 17
        {
            "cols": [{"colspan": 2, "column": true}, {"value": "18"}],
            "index": 18,
            "title": "本期应补（退）费额",
            "name": "bqybtfe",
            "type": "float2",
            readonly: true
        }, // 18
        {
            "cols": [{"colspan": 2, "column": true}, {"value": "19"}],
            "index": 19,
            "title": "本期检查已补缴费额",
            "name": "bqjcybjfe",
            "type": "float2"
        }  // 19

    ];
    var DEFAULT_NSR_INFO = {
        "returnCode": "00", /* 返回码 */
        "returnMessage": "", /* 返回信息 */
        "serverTime": "", /* 系统当前时间 */
        "nsrsbh": "120101010101010", /* 纳税人识别号 */
        "nsrmc": "测试纳税人名称", /* 纳税人名称 */
        "zsxmDm": "", /* 征收项目代码 */
        "zsxmMc": "", /* 征收项目名称 */
        "nsqxDm": "", /* 纳税期限代码 */
        "nsqxMc": "", /* 纳税期限名称 */
        "sbqx": "", /* 申报期限 */
        "vjkqx": "", /* 缴款期限 */
        "sssqQ": "2017-03-01", /* 所属属期起 */
        "sssqZ": "2017-03-31", /* 所属属期止 */
        "yqsbBz": "N", /* 逾期申报标志 */
        "ysbBz": "N", /* 已申报标志 */
        "yjkBz": "N", /* 已缴款标志 */
        "yqwrdybrBz": "N", /* 逾期未认定一般人标志 */
        "dqdeBz": "N", /* 定期定额标志（征收方式） */
        "jcxxBz": "Y", /* 基础信息标志 */
        "sfXgm": "Y", /* 是否为小规模 */
        "yshwYjs": 0, /* 应税货物预缴数 */
        "ysfwYjs": 0, /* 服务、不动产和无形资产预缴数 */
        "szlbDm": "03", /* 税种类别代码 */
        "szlbMc": "混征增值税", /* 税种类别名称 */
        "jmzg": "N", /* 减免资格 */
        "qzd": 0, /* 起征点 */
        "fwqzd": 0, /* 服务起征点 */
        "ydkzyfpje": 0, /* 已代开专用发票金额 */
        "qcye": 0, /* 附表四期初余额 */
        "bqfse": 0, /* 附表四本期发生额 */
        "hdxseHw": 0, /* 应税货物核定销售额 */
        "hdxseFw": 0, /* 服务、不动产和无形资产核定销售额 */
        "hdynseHw": 0, /* 应税货物核定应纳税额 */
        "hdynseFw": 0, /* 服务、不动产和无形资产核定应纳税额 */
        "is1924": false // 2019-7-1~2024-12-31日减税降费正常期
        // "whsyjsf": {
        //     "zspmDm": "",	// 征收品目代码
        //     // "fl": 0.03,      // 费率
        //
        //     "zsxmDm": "",	// 征收项目代码
        //     "zsxmMc": "",	// 征收项目名称
        //     "nsqxDm": "",	// 纳税期限代码
        //     "nsqxMc": "",	// 纳税期限名称
        //     "sbqx": "",	// 申报期限
        //     "jkqx": "",	// 缴款期限
        //     "sssqQ": "20170301",	// 所属属期起
        //     "sssqZ": "20170331",	// 所属属期止
        //     "yqsbBz": "N",	 // 逾期申报标志
        //     "ysbBz": "N",	// 已申报标志
        //     "yjkBz": "N",	// 已缴款标志
        //     "cezsBz": "Y",	// 差额征税标志
        //     "jcxmQcje": 0,	// 减除项目期初金额
        //     "xwBz": "N" // 小微标志
        // },
        // "whsyjsf_yl": {
        //     "zspmDm": "",	// 征收品目代码
        //     // "fl": 0.05,      // 费率
        //
        //     "zsxmDm": "",	// 征收项目代码
        //     "zsxmMc": "",	// 征收项目名称
        //     "nsqxDm": "",	// 纳税期限代码
        //     "nsqxMc": "",	// 纳税期限名称
        //     "sbqx": "",	// 申报期限
        //     "jkqx": "",	// 缴款期限
        //     "sssqQ": "20170301",	// 所属属期起
        //     "sssqZ": "20170331",	// 所属属期止
        //     "yqsbBz": "N",	 // 逾期申报标志
        //     "ysbBz": "N",	// 已申报标志
        //     "yjkBz": "N",	// 已缴款标志
        //     "cezsBz": "Y",	// 差额征税标志
        //     "jcxmQcje": 0,	// 减除项目期初金额
        //     "xwBz": "N", // 小微标志
        // }
    };

    var DEFAULT_GRID_VALUES = {
        "zb": {
            "jfsr": 0,      //  1   应征收入
            "mzsr": 0,	    //  2   免征收入
            "kcxmqcje": 0,  //  3   减除项目期初金额
            "kcxmbqfse": 0, //  4   减除项目本期发生额
            "bqkce": 0,     //  5   应征收入减除额
            "mzsrjce": 0,	//  6   免征收入减除额
            "kcxmqmye": 0,  //  7   减除项目期末余额
            "jfxse": 0,	    //  8   计费销售额
            "fl": 0.03,     //  9   费率
            "yjfe": 0,	    //  10  应缴费额
            "qcwjfe": 0,	//  11  期初未缴费额（多缴为负）
            "bqyjnfe": 0,	//  12  本期已缴费额
            "bqyjfe": 0,	//  13  本期预缴费额
            "bqjnsqfe": 0,	//  14  本期缴纳上期费额
            "bqjnqfe": 0,	//  15  本期缴纳欠费额
            "qmwjfe": 0,	//  16  期末未缴费额（多缴为负）
            "qjfe": 0,	    //  17  其中：欠缴费额
            "bqybtfe": 0,	//  18  本期应补退费额
            "bqjcybjfe": 0  //	19  本期检查已补缴费额

        },
        "zb_yl": {
            "jfsr": 0,      //  1   应征收入
            "mzsr": 0,	    //  2   免征收入
            "kcxmqcje": 0,  //  3   减除项目期初金额
            "kcxmbqfse": 0, //  4   减除项目本期发生额
            "bqkce": 0,     //  5   应征收入减除额
            "mzsrjce": 0,	//  6   免征收入减除额
            "kcxmqmye": 0,  //  7   减除项目期末余额
            "jfxse": 0,	    //  8   计费销售额
            "fl": 0.03,     //  9   费率
            "yjfe": 0,	    //  10  应缴费额
            "qcwjfe": 0,	//  11  期初未缴费额（多缴为负）
            "bqyjnfe": 0,	//  12  本期已缴费额
            "bqyjfe": 0,	//  13  本期预缴费额
            "bqjnsqfe": 0,	//  14  本期缴纳上期费额
            "bqjnqfe": 0,	//  15  本期缴纳欠费额
            "qmwjfe": 0,	//  16  期末未缴费额（多缴为负）
            "qjfe": 0,	    //  17  其中：欠缴费额
            "bqybtfe": 0,	//  18  本期应补退费额
            "bqjcybjfe": 0  //	19  本期检查已补缴费额

        },
        "mx": [],
        "mx_yl": []
    };

    var __init__ = function (_nsrInfo, _defaultValue) {
        if (typeof _nsrInfo == "string") {
            _nsrInfo = JSON.parse(_nsrInfo);
        }
        if (typeof _defaultValue == "string") {
            _defaultValue = JSON.parse(_defaultValue);
        }
        // 计算初始化数据，全部数据采用深度克隆和空对象继承的方式处理，方式在程序运行中对基础对象信息产生修改
        var mainTableColumnNames = tools.deepClone(MAIN_TABLE); // 展示信息的克隆
        var nsrInfo = JSON.extend({}, DEFAULT_NSR_INFO, _nsrInfo); // 纳税人信息的克隆
        var gridValues = JSON.extend({}, DEFAULT_GRID_VALUES, _defaultValue); // 申报数据的克隆
        var inputAlias = new Array(mainTableColumnNames.length); // 这个是为了和APP通讯使用的对象结构，按照输入顺序整理
        var inputAlias_yl = new Array(mainTableColumnNames.length); // 这个是为了和APP通讯使用的对象结构，按照输入顺序整理
        var alias = {zb: {}, zb_yl: {}}; // 这个是给自动计算和校验使用的，按照行号定义key值

        // 补充特殊信息
        var qYear = 0;
        var qMonth = 0;
        var zMonth = 0;
        var zYear = 0;
        if (whasGGY(nsrInfo) || (!whasYLY(nsrInfo) && nsrInfo.whsyjsf != undefined)) {
            // 有广告，或者都已申报
            qYear = tools.parseValue(nsrInfo.whsyjsf.sssqQ.substring(0, 4), "float2");
            qMonth = tools.parseValue(nsrInfo.whsyjsf.sssqQ.substring(5, 6), "float2");
            zMonth = tools.parseValue(nsrInfo.whsyjsf.sssqZ.substring(5, 6), "float2");
            zYear = tools.parseValue(nsrInfo.whsyjsf.sssqZ.substring(0, 4), "float2");

            gridValues.zb.zspmDm = nsrInfo.whsyjsf.zspmDm;
            gridValues.zb.kcxmqcje = nsrInfo.whsyjsf.jcxmQcje;                              // 减除项目期初金额
        }
        if (whasYLY(nsrInfo) || (!whasGGY(nsrInfo) && nsrInfo.whsyjsf_yl != undefined)) {
            qYear = tools.parseValue(nsrInfo.whsyjsf_yl.sssqQ.substring(0, 4), "float2");
            qMonth = tools.parseValue(nsrInfo.whsyjsf_yl.sssqQ.substring(5, 6), "float2");
            zMonth = tools.parseValue(nsrInfo.whsyjsf_yl.sssqZ.substring(5, 6), "float2");
            zYear = tools.parseValue(nsrInfo.whsyjsf_yl.sssqZ.substring(0, 4), "float2");

            gridValues.zb_yl.zspmDm = nsrInfo.whsyjsf_yl.zspmDm;
            gridValues.zb_yl.kcxmqcje = nsrInfo.whsyjsf_yl.jcxmQcje;                        // 减除项目期初金额
        }
        nsrInfo.is1924 = qYear >= 2019 && qMonth >= 7 && zYear < 2025;   // 2019年7月1日~2024年12月31日
        nsrInfo.is2020 = qYear == 2020 && zYear == 2020;
        if (nsrInfo.is2020) {
            if (zMonth - qMonth > 2) {
                // 年报
                nsrInfo.mzsrMax2020 = 247200;
            } else if (zMonth - qMonth > 0) {
                // 季报
                nsrInfo.mzsrMax2020 = 61800;
            } else {
                // 月报
                nsrInfo.mzsrMax2020 = 20600;
            }
        }

        //  初始化报表显示
        setBb(nsrInfo);

        /**
         * 读取数据
         * @param {Object} cache
         * @param {Object} index
         */
        var getValue = function (cache, index) {
            return gridValues[cache][alias[cache][index].name];
        };

        /**
         * 设置数据
         * @param {Object} cache
         * @param {Object} index
         */
        var setValue = function (cache, index, value) {
            var type = alias[cache][index].type;
            gridValues[cache][alias[cache][index].name] = tools.parseValue(value, type);
            autoCompute(cache, alias[cache][index].name, false);
        };
        /**
         * 自动计算
         * @param {Object} cache 本次修改的内容所属列
         * @param {Object} name 本次修改的内容节点
         * @param {Object} all 全部计算
         */
        var autoCompute = function (cache, name, all) {
            // 1：第3行_本月数=上期第7行_本年累计。cf_get_zzs_lj(7,12,"1") // 记录：在APP申报中，此数据为从基础数据中带出，不参与计算
            // 3：第5行_本月数：第3行+第4行<=第1行时,第5行=第3行+第4行,否则=第1行
            var __cache__ = cache;
            if (all || alias[__cache__][1].name == name || alias[__cache__][3].name == name || alias[__cache__][4].name == name) {
                setValue(__cache__, 5, Math.min(getValue(__cache__, 1), getValue(__cache__, 3) + getValue(__cache__, 4)));
                if (!all) {
                    autoCompute(__cache__, alias[__cache__][5].name);
                }
            }
            // 4：第6行_本月数：第3行+第4行<=第2行时,第6行=第3行+第4行,否则=第2行
            if (all || alias[__cache__][2].name == name || alias[__cache__][3].name == name || alias[__cache__][4].name == name) {
                setValue(__cache__, 6, Math.min(getValue(__cache__, 2), getValue(__cache__, 3) + getValue(__cache__, 4)));
                if (!all) {
                    autoCompute(__cache__, alias[__cache__][6].name);
                }
            }
            // 5：第7行_本月数=第3行+第4行-第5行-第6行
            if (all || alias[__cache__][3].name == name || alias[__cache__][4].name == name || alias[__cache__][5].name == name || alias[__cache__][6].name == name) {
                setValue(__cache__, 7, getValue(__cache__, 3) + getValue(__cache__, 4) - getValue(__cache__, 5) - getValue(__cache__, 6));
                if (!all) {
                    autoCompute(__cache__, alias[__cache__][7].name);
                }
            }
            // 6：第8行_本月数=第1行-第5行，自动计算可修改
            if (all || alias[__cache__][1].name == name || alias[__cache__][5].name == name) {
                setValue(__cache__, 8, getValue(__cache__, 1) - getValue(__cache__, 5));
                if (!all) {
                    autoCompute(__cache__, alias[__cache__][8].name);
                }
            }
            // 7：第10行_本月数=第8行*第9行。round(F13*F14,2)
            if (all || alias[__cache__][8].name == name || alias[__cache__][9].name == name) {
                setValue(__cache__, 10, getValue(__cache__, 8) * getValue(__cache__, 9));
                if (!all) {
                    autoCompute(__cache__, alias[__cache__][10].name);
                }
            }
            // 8：第11行_本月数=上期第16行_本年累计。cf_get_zzs_lj(7,21,"1") // 在 APP 申报中，没有上期数据留底，且基础信息中未返回此项信息，此项信息手动输入
            // 9：第12行_本月数=第13行+第14行+第15行
            if (all || alias[__cache__][13].name == name || alias[__cache__][14].name == name || alias[__cache__][15].name == name) {
                setValue(__cache__, 12, getValue(__cache__, 13) + getValue(__cache__, 14) + getValue(__cache__, 15));
                if (!all) {
                    autoCompute(__cache__, alias[__cache__][12].name);
                }
            }
            // 10：第16行_本月数=第10行+第11行-第12行
            if (all || alias[__cache__][10].name == name || alias[__cache__][11].name == name || alias[__cache__][12].name == name) {
                setValue(__cache__, 16, getValue(__cache__, 10) + getValue(__cache__, 11) - getValue(__cache__, 12));
                if (!all) {
                    autoCompute(__cache__, alias[__cache__][16].name);
                }
            }
            // 11：第17行_本月数：第11行-第14行-第15行>=0, 第17行=第11行-第14行-第15行，否则第17行=0
            if (all || alias[__cache__][11].name == name || alias[__cache__][14].name == name || alias[__cache__][15].name == name) {
                setValue(__cache__, 17, Math.max(getValue(__cache__, 11) - getValue(__cache__, 14) - getValue(__cache__, 15), 0));
                if (!all) {
                    autoCompute(__cache__, alias[__cache__][17].name);
                }
            }
            if (all || alias[__cache__][10].name == name || alias[__cache__][13].name == name) {
                var v10 = getValue(__cache__, 10);
                var v13 = getValue(__cache__, 13);
                if (nsrInfo.is2020) {
                    // 二、2020.5.31,将《文化事业建设费申报表》第18栏“本期应补（退）费额”设置为：属期为2020年1月1日至2020年12月31日时，为0。
                    setValue(__cache__, 18, 0);
                } else {
                    if (nsrInfo.is1924 && tools.parseValue(v10, "float2") > 0) {
                        // 当申报属期是2019年7月1日至2024年12月31日之间的 ，并且 10> 0 时，18=10*归属中央收入比例*（1-50%）+10*归属地方收入比例*（1-地方减征比例）-13 。其他情况，第18栏“本期应补（退）费额”= 10-13。
                        // 	 其中：归属中央收入比例为80%，归属地方收入比例为20%，地方减征比例为50%
                        setValue(__cache__, 18, tools.parseValue(v10 * 0.5, "float2") - v13);
                    } else {
                        // 12：第18行_本月数=第10行-第13行
                        setValue(__cache__, 18, v10 - v13);
                    }
                }
                if (!all) {
                    autoCompute(__cache__, alias[__cache__][18].name);
                }
            }
            // 13：第1、2、4、5、6、8、10、12、13、14、15、19行_本年累计=本期_本月数+上期_本年累计，例如19行：F24+cf_get_zzs_lj(col(),row(),"0") // APP 中不显示累计数
            // 14：第7、16行=本期_本月数 // APP 中不显示累计数
        };
        (function () {
            // 附表录入项目及类型
            var infos = [
                {name: 'kpfNsrsbh', type: 'string nsrsbh', title: "开票方纳税人识别号"},
                {name: 'kpfDwmc', type: 'string str(80)', title: "开票方单位名称"},
                {name: 'fwxmMc', type: 'string str(40)', title: "服务项目名称"},
                {name: 'whsyPzzlDm', type: 'string whsyPzzlDm', title: "凭证种类"},
                {name: 'fphm', type: 'string str(40)', title: "凭证号码"},
                {name: 'je', type: 'float2', title: "金额"}
            ];
            // 凭证种类
            var pzzlDm = {
                "1": "发票",
                "2": "财政票据",
                "3": "境外支付单据"
            };
            // 根据征收类别代码设置应税货物及劳务和服务、不动产和无形资产的可编辑属性
            for (var i = 0; i < mainTableColumnNames.length; i++) {
                var row = mainTableColumnNames[i];

                // 计算别名
                var zbNode = {
                    "name": row.name,
                    "cache": "zb",
                    "label": "广告业   第" + row.index + "栏：" + row.title.replace(new RegExp("　", "gi"), ""),
                    "type": row.type,
                    "index": 100 + row.index,
                    "disabled": row.disabled,
                    "readonly": row.readonly
                };
                alias.zb[i + 1] = inputAlias[i] = zbNode;

                // 计算别名
                var zbNode_yl = {
                    "name": row.name,
                    "cache": "zb_yl",
                    "label": "娱乐业   第" + row.index + "栏：" + row.title.replace(new RegExp("　", "gi"), ""),
                    "type": row.type,
                    "index": 100 + row.index,
                    "disabled": row.disabled,
                    "readonly": row.readonly
                };
                alias.zb_yl[i + 1] = inputAlias_yl[i] = zbNode_yl;
            }
            // 首先进行一次自动计算
            autoCompute("zb", "", true);
            autoCompute("zb_yl", "", true);
            /**
             * 填充标题模版
             */
            var title = new Vue({
                el: "#base_info",
                data: {
                    nsr: nsrInfo
                },
                computed: {
                    hasGGY: function () {
                        return whasGGY(nsrInfo);
                    },
                    hasYLY: function () {
                        return whasYLY(nsrInfo)
                    }
                },
                methods: {
                    selectSbb: function () {
                        var sbb = document.getElementById("sbb");
                        showBb(sbb.options[sbb.selectedIndex].value)
                    }
                }
            });

            /**
             * 文化事业建设费主表模版
             */
            var whsyjsf_zb = new Vue({
                el: "#whsyjsf_zb",
                data: {
                    nsr: nsrInfo,
                    rowsData: mainTableColumnNames,
                    gridData: gridValues,
                    inputData: inputAlias
                },
                methods: {
                    setValue: function (index) {
                        var inputData = this.inputData;
                        var inputInfo = inputData[index];
                        if (inputInfo.disabled || inputInfo.readonly) {
                            return;
                        }
                        var defautValue = this.gridData[inputInfo.cache][inputInfo.name];
                        var value = prompt(JSON.stringify(inputInfo), defautValue);
                        if (!!value) {
                            var __value__ = JSON.parse(value);

                            this.gridData[inputInfo.cache][inputInfo.name] = tools.parseValue(__value__.value, inputInfo.type);
                            autoCompute(inputInfo.cache, inputInfo.name);
                            var step = 0;
                            if ("1" == __value__.flag) {
                                step = -1;
                            } else if ("2" == __value__.flag) {
                                step = 1;
                            }
                            if (step != 0) {
                                var nextIndex = index;
                                while (true) {
                                    nextIndex += step;
                                    if (nextIndex < 0) {
                                        nextIndex = inputData.length - 1;
                                    }
                                    if (nextIndex >= inputData.length) {
                                        nextIndex = 0;
                                    }
                                    var nextInputInfo = inputData[nextIndex];
                                    if (!nextInputInfo.readonly && !nextInputInfo.disabled) {
                                        break;
                                    }
                                }
                                this.setValue(nextIndex);
                            }
                        }
                    }
                }
            });
            /**
             * 文化事业建设费附表模版
             */
            var whsyjsf_fb = new Vue({
                el: "#whsyjsf_fb",
                data: {
                    nsr: nsrInfo,
                    gridData: gridValues,
                    pzzlDms: pzzlDm
                },
                computed: {
                    totalAmount: function () {
                        var sum = 0;
                        for (var i = 0; i < this.gridData.mx.length; i++) {
                            sum += this.gridData.mx[i].je;
                        }
                        return tools.parseValue(sum, "float2");
                    }
                },
                methods: {
                    setValue: function (row, index) {
                        var notices = {
                            "name": infos[index].name,
                            "cache": "mx_" + row,
                            "label": "第" + (row + 1) + "行、" + infos[index].title,
                            "type": infos[index].type,
                            "index": row * 100 + index + 1
                        };
                        var defautValue = this.gridData.mx[row][notices.name];
                        var value = prompt(JSON.stringify(notices), defautValue);
                        if (!!value) {
                            var __value__ = JSON.parse(value);
                            this.gridData.mx[row][notices.name] = tools.parseValue(__value__.value, notices.type);
                            var step = 0;
                            if ("1" == __value__.flag) {
                                step = -1;
                            } else if ("2" == __value__.flag) {
                                step = 1;
                            }
                            if (step != 0) {
                                var nextIndex = index + step;
                                if (nextIndex < 0) {
                                    nextIndex = infos.length - 1;
                                }
                                if (nextIndex >= infos.length) {
                                    nextIndex = 0;
                                }
                                this.setValue(row, nextIndex);
                            }
                        }
                    },
                    addItem: function () {
                        this.gridData.mx.push({
                            "kpfNsrsbh": "", // 开票方纳税人识别号
                            "kpfDwmc": "", // 开票方单位名称
                            "whsyPzzlDm": "", // 凭证种类：1、发票；2、财政票据；3、境外支付单据
                            "fphm": "", // 发票号码
                            "fwxmMc": "", // 服务项目名称
                            "je": 0 // 金额
                        });
                    },
                    remove: function (index) {
                        this.gridData.mx.splice(index, 1);
                    }
                }
            });
            /**
             * 文化事业建设费主表模版
             */
            var whsyjsf_zb_yl = new Vue({
                el: "#whsyjsf_zb_yl",
                data: {
                    nsr: nsrInfo,
                    rowsData: mainTableColumnNames,
                    gridData: gridValues,
                    inputData: inputAlias_yl
                },
                methods: {
                    setValue: function (index) {
                        var inputData = this.inputData;
                        var inputInfo = inputData[index];
                        if (inputInfo.disabled || inputInfo.readonly) {
                            return;
                        }
                        var defautValue = this.gridData[inputInfo.cache][inputInfo.name];
                        var value = prompt(JSON.stringify(inputInfo), defautValue);
                        if (!!value) {
                            var __value__ = JSON.parse(value);

                            this.gridData[inputInfo.cache][inputInfo.name] = tools.parseValue(__value__.value, inputInfo.type);
                            autoCompute(inputInfo.cache, inputInfo.name);
                            var step = 0;
                            if ("1" == __value__.flag) {
                                step = -1;
                            } else if ("2" == __value__.flag) {
                                step = 1;
                            }
                            if (step != 0) {
                                var nextIndex = index;
                                while (true) {
                                    nextIndex += step;
                                    if (nextIndex < 0) {
                                        nextIndex = inputData.length - 1;
                                    }
                                    if (nextIndex >= inputData.length) {
                                        nextIndex = 0;
                                    }
                                    var nextInputInfo = inputData[nextIndex];
                                    if (!nextInputInfo.readonly && !nextInputInfo.disabled) {
                                        break;
                                    }
                                }
                                this.setValue(nextIndex);
                            }
                        }
                    }
                }
            });
            /**
             * 文化事业建设费附表模版
             */
            var whsyjsf_fb_yl = new Vue({
                el: "#whsyjsf_fb_yl",
                data: {
                    nsr: nsrInfo,
                    gridData: gridValues,
                    pzzlDms: pzzlDm
                },
                computed: {
                    totalAmount: function () {
                        var sum = 0;
                        for (var i = 0; i < this.gridData.mx_yl.length; i++) {
                            sum += this.gridData.mx_yl[i].je;
                        }
                        return tools.parseValue(sum, "float2");
                    }
                },
                methods: {
                    setValue: function (row, index) {
                        var notices = {
                            "name": infos[index].name,
                            "cache": "mx_yl_" + row,
                            "label": "第" + (row + 1) + "行、" + infos[index].title,
                            "type": infos[index].type,
                            "index": row * 100 + index + 1
                        };
                        var defautValue = this.gridData.mx_yl[row][notices.name];
                        var value = prompt(JSON.stringify(notices), defautValue);
                        if (!!value) {
                            var __value__ = JSON.parse(value);
                            this.gridData.mx_yl[row][notices.name] = tools.parseValue(__value__.value, notices.type);
                            var step = 0;
                            if ("1" == __value__.flag) {
                                step = -1;
                            } else if ("2" == __value__.flag) {
                                step = 1;
                            }
                            if (step != 0) {
                                var nextIndex = index + step;
                                if (nextIndex < 0) {
                                    nextIndex = infos.length - 1;
                                }
                                if (nextIndex >= infos.length) {
                                    nextIndex = 0;
                                }
                                this.setValue(row, nextIndex);
                            }
                        }
                    },
                    addItem: function () {
                        this.gridData.mx_yl.push({
                            "kpfNsrsbh": "", // 开票方纳税人识别号
                            "kpfDwmc": "", // 开票方单位名称
                            "whsyPzzlDm": "", // 凭证种类：1、发票；2、财政票据；3、境外支付单据
                            "fphm": "", // 发票号码
                            "fwxmMc": "", // 服务项目名称
                            "je": 0 // 金额
                        });
                    },
                    remove: function (index) {
                        this.gridData.mx_yl.splice(index, 1);
                    }
                }
            });
        })();
        return {
            getValues: function (callBackName) {
                var resultValues = JSON.stringify(gridValues);

                if (callBackName != undefined) {
                    if (typeof callBackName == "function") {
                        callBackName(resultValues);
                    } else {
                        (new Function(callBackName + " (JSON.stringify(" + resultValues + "));"))()
                    }
                } else {
                    window.webkit.messageHandlers.iosTalbeAllValuesCallback.postMessage(resultValues);
                }
            },
            loadSuc: function (type) {
                if ('whsyjsf' == type && whasGGY(nsrInfo)) {
                    nsrInfo.whsyjsf.ysbBz = "Y";
                } else if ('whsyjsf_yl' == type && whasYLY(nsrInfo)) {
                    nsrInfo.whsyjsf_yl.ysbBz = "Y";
                }

                setBb(nsrInfo);
            },
            validate: function (callBackName) {
                var VALIDATE_SIGN = {
                    "success": 0,
                    "error": 1,
                    "warning": 2
                };
                var validateSign = VALIDATE_SIGN.success;
                var message = [];
                var addError = function (errorMessage) {
                    validateSign = VALIDATE_SIGN.error;
                    message.push("（强制校验）" + errorMessage);
                };
                /**
                 * 约等于
                 *
                 * @param {Object} left 等式左边的值
                 * @param {Object} right 等式右边的值
                 * @param {Object} errorRange 误差范围
                 */
                var approximate = function (left, right, errorRange) {
                    var dValue = tools.parseValue(Math.abs(left - right), "float2");
                    var eRange = tools.parseValue(Math.abs(errorRange), "float2");
                    return dValue <= eRange;
                };
                // 2.2表内校验
                if (whasGGY(nsrInfo)) {
                    // 广告业
                    // 1：第1行_本月数：第1栏与第2栏不能同时填写数值
                    var ln1 = gridValues.zb.jfsr;
                    var ln2 = gridValues.zb.mzsr;
                    if (ln1 != 0 && ln2 != 0) {
                        addError("文化事业建设费申报表(广告业)   第一栏“应征收入”和第二栏“免征收入”不能同时录入数据！");
                    }

                    if (nsrInfo.is2020 && ln2 > nsrInfo.mzsrMax2020) {
                        // 一、2020.5.31,将《文化事业建设费申报表》第2栏“免征收入”设置为：属期为2020年1月1日至2020年12月31日时，不得超过月20600季61800年247200。
                        addError("文化事业建设费申报表(广告业)   第二栏“免征收入”不能超过" + nsrInfo.mzsrMax2020 + "！");
                    }

                    // 2.3表间公式
                    // 1：第4行_本月数=《应税服务减除项目清单》的合计金额。( [16501_002_02,jehj,BQ,N] + 0 )
                    if (nsrInfo.whsyjsf.cezsBz.toUpperCase() == "Y") {
                        var ln4 = gridValues.zb.kcxmbqfse;
                        var totalAmount = 0;
                        for (var i = 0; i < gridValues.mx.length; i++) {
                            totalAmount += gridValues.mx[i].je;
                            if (gridValues.mx[i].whsyPzzlDm == "1" && gridValues.mx[i].kpfNsrsbh == "") {
                                addError("应税服务减除项目清单(广告业)   第" + (i + 1) + "行“凭证种类”是发票，请录入同行的“开票方纳税人识别号”！");
                            }
                        }
                        if (ln4 != totalAmount) {
                            addError("文化事业建设费申报表(广告业)   第四栏“减除项目本期发生额”应和应税服务减除项目清单(广告业)   第六列“金额”合计一致！");
                        }

                    }
                }
                if (whasYLY(nsrInfo)) {
                    // 娱乐业
                    // 1：第1行_本月数：第1栏与第2栏不能同时填写数值
                    var ln1 = gridValues.zb_yl.jfsr;
                    var ln2 = gridValues.zb_yl.mzsr;
                    if (ln1 != 0 && ln2 != 0) {
                        addError("文化事业建设费申报表(娱乐业)   第一栏“应征收入”和第二栏“免征收入”不能同时录入数据！");
                    }

                    if (nsrInfo.is2020 && ln2 > nsrInfo.mzsrMax2020) {
                        // 一、2020.5.31,将《文化事业建设费申报表》第2栏“免征收入”设置为：属期为2020年1月1日至2020年12月31日时，不得超过月20600季61800年247200。
                        addError("文化事业建设费申报表(娱乐业)   第二栏“免征收入”不能超过" + nsrInfo.mzsrMax2020 + "！");
                    }

                    // 2.3表间公式
                    // 1：第4行_本月数=《应税服务减除项目清单》的合计金额。( [16501_002_02,jehj,BQ,N] + 0 )
                    if (nsrInfo.whsyjsf_yl.cezsBz.toUpperCase() == "Y") {
                        var ln4 = gridValues.zb_yl.kcxmbqfse;
                        var totalAmount = 0;
                        for (var i = 0; i < gridValues.mx_yl.length; i++) {
                            totalAmount += gridValues.mx_yl[i].je;
                            if (gridValues.mx_yl[i].whsyPzzlDm == "1" && gridValues.mx_yl[i].kpfNsrsbh == "") {
                                addError("应税服务减除项目清单(娱乐业)   第" + (i + 1) + "行“凭证种类”是发票，请录入同行的“开票方纳税人识别号”！");
                            }
                        }
                        if (ln4 != totalAmount) {
                            addError("文化事业建设费申报表(娱乐业)   第四栏“减除项目本期发生额”应和应税服务减除项目清单(娱乐业)   第六列“金额”合计一致！");
                        }

                    }
                }

                if (callBackName != undefined) {
                    if (typeof callBackName == "function") {
                        callBackName(validateSign, message.join("|"));
                    } else {
                        (new Function(callBackName + "(" + validateSign + ", \"" + message.join("|") + "\");"))()
                    }
                } else {
                    window.webkit.messageHandlers.iosValidateCallback.postMessage([validateSign, message.join("|")]);
                }
            }
        };
    };

    var tableInfo = null;
    /**
     * 初始化录入页面
     * @param _nsrInfo JSON字符串 通过申报接口返回的企业基本信息，需要添加nsrsbh
     * @param _defaultValue JSON字符串  原生应用部分保存的申报缓存数据，和申报接口报文格式一致
     */
    window.loadTable = function (_nsrInfo, _defaultValue) {
        tableInfo = __init__(_nsrInfo, _defaultValue);
    };

    /**
     * 获取所有的缓存数据
     *
     * @param callBackName 回调函数名称，需要接收一个参数，参数为JSON字符串结构的缓存数据，和申报报文数据一致
     *                     (serviceName、nsrsbh、sssqQ、sssqZ四个节点如果在初始化时传入了，则一并返回，否则不包括）
     */
    window.talbeAllValues = function (callBackName) {
        if (tableInfo) {
            tableInfo.getValues(callBackName);
        }
    };

    /**
     * 进行数据校验
     *
     * @param callBackName 回调函数名称，需要接收2个参数，
     *                     第一个参数为校验结果，0：表示通过校验，1：表示有提示性校验未通过，2：表示有强制校验未通过
     *                     第二个参数为字符串，用来描述错误信息，如果有多条错误，则使用 “|”进行分割
     */
    window.validate = function (callBackName) {
        if (tableInfo) {
            tableInfo.validate(callBackName);
        }
    };

    /**
     * 单个税种申报成功刷新页面
     * @param type         税种（whsyjsf, whsyjsf_yl）
     */
    window.loadSuc = function (type) {
        if (tableInfo) {
            tableInfo.loadSuc(type);
            tableInfo.loadSuc(type);
        }
    };

    // 是否广告业未申报
    window.whasGGY = function (nsrInfo) {
        return nsrInfo.whsyjsf != undefined && nsrInfo.whsyjsf.sssqQ != undefined && nsrInfo.whsyjsf.sssqQ.length == 8 && nsrInfo.whsyjsf.ysbBz != "Y";
    };
    // 是否娱乐业未申报
    window.whasYLY = function (nsrInfo) {
        return nsrInfo.whsyjsf_yl != undefined && nsrInfo.whsyjsf_yl.sssqQ != undefined && nsrInfo.whsyjsf_yl.sssqQ.length == 8 && nsrInfo.whsyjsf_yl.ysbBz != "Y";
    };
    // 下拉选择框中选中报表
    window.setSelectedOption = function (value) {
        setTimeout(function () {
            var select = document.getElementById("sbb");
            for (var i = 0; i < select.options.length; i++) {
                var opt = select.options[i];
                if (value === opt.value) {
                    opt.selected = true;
                }
            }
        }, 400);
    };
    window.setBb = function (nsrInfo) {
        if (whasGGY(nsrInfo) || (!whasYLY(nsrInfo) && nsrInfo.whsyjsf != undefined)) {
            showBb("zb");
        } else if (whasYLY(nsrInfo) || (!whasGGY(nsrInfo) && nsrInfo.whsyjsf_yl != undefined)) {
            showBb("zb_yl");
        } else {
            showBb("zb");
        }
    };
    // 显示报表
    window.showBb = function (bb) {
        if (bb == 'zb') {
            // 广告主表
            document.getElementById("whsyjsf_zb").style.display = "block";
            setSelectedOption("zb");
            document.getElementById("whsyjsf_fb").style.display = "none";
            document.getElementById("whsyjsf_zb_yl").style.display = "none";
            document.getElementById("whsyjsf_fb_yl").style.display = "none";

            document.getElementById("work_content").style.width = WIDTH_CONTENT_S + "px";
            document.getElementById("whsyjsf_zb").style.width = (WIDTH_CONTENT_S - 10) + "px";
        } else if (bb == 'fb') {
            // 广告附表
            document.getElementById("whsyjsf_zb").style.display = "none";
            document.getElementById("whsyjsf_fb").style.display = "block";
            setSelectedOption("fb");
            document.getElementById("whsyjsf_zb_yl").style.display = "none";
            document.getElementById("whsyjsf_fb_yl").style.display = "none";

            document.getElementById("work_content").style.width = WIDTH_CONTENT_M + "px";
            document.getElementById("whsyjsf_fb").style.width = (WIDTH_CONTENT_M - 10) + "px";
        } else if (bb == 'zb_yl') {
            // 娱乐主表
            document.getElementById("whsyjsf_zb").style.display = "none";
            document.getElementById("whsyjsf_fb").style.display = "none";
            document.getElementById("whsyjsf_zb_yl").style.display = "block";
            setSelectedOption("zb_yl");
            document.getElementById("whsyjsf_fb_yl").style.display = "none";

            document.getElementById("work_content").style.width = WIDTH_CONTENT_S + "px";
            document.getElementById("whsyjsf_zb_yl").style.width = (WIDTH_CONTENT_S - 10) + "px";
        } else if (bb == 'fb_yl') {
            // 娱乐附表
            document.getElementById("whsyjsf_zb").style.display = "none";
            document.getElementById("whsyjsf_fb").style.display = "none";
            document.getElementById("whsyjsf_zb_yl").style.display = "none";
            document.getElementById("whsyjsf_fb_yl").style.display = "block";
            setSelectedOption("fb_yl");

            document.getElementById("work_content").style.width = WIDTH_CONTENT_M + "px";
            document.getElementById("whsyjsf_fb_yl").style.width = (WIDTH_CONTENT_M - 10) + "px";
        }
    };
})();